"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.constructLintConfig = constructLintConfig;
exports.readConfigLint = readConfigLint;
var _path = _interopRequireDefault(require("path"));
var _fileUtils = require("../utils/fileUtils");
var _logger = require("../utils/logger");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function readConfigLint() {
  var lintConfigPath = _path["default"].resolve(process.cwd(), 'lint.config.js');
  if ((0, _fileUtils.checkIfFileExists)(lintConfigPath)) {
    return lintConfigPath;
  }
}
function constructLintConfig(configPath, lintFor) {
  var constructLintConfig = require(_path["default"].resolve(process.cwd(), configPath));
  var _constructLintConfig$ = constructLintConfig[lintFor],
    _constructLintConfig$2 = _constructLintConfig$.extend,
    extend = _constructLintConfig$2 === void 0 ? [] : _constructLintConfig$2,
    _constructLintConfig$3 = _constructLintConfig$.plugins,
    plugins = _constructLintConfig$3 === void 0 ? [] : _constructLintConfig$3,
    _constructLintConfig$4 = _constructLintConfig$.ignorePatterns,
    ignorePatterns = _constructLintConfig$4 === void 0 ? [] : _constructLintConfig$4,
    _constructLintConfig$5 = _constructLintConfig$.rules,
    rules = _constructLintConfig$5 === void 0 ? {} : _constructLintConfig$5,
    _constructLintConfig$6 = _constructLintConfig$.options,
    options = _constructLintConfig$6 === void 0 ? {} : _constructLintConfig$6;
  return _objectSpread(_objectSpread({}, {
    env: getLintEnv(),
    "extends": getExtends(extend),
    parserOptions: getParserOptions(),
    plugins: getPlugins(plugins),
    ignorePatterns: getIgnorePattern(ignorePatterns),
    rules: getRules(rules)
  }), getOtherOptions(options));
}
function getIgnorePattern(ignorePatterns) {
  return ignorePatterns;
}
function getLintEnv(envObjectLint) {
  return _objectSpread(_objectSpread({}, envObjectLint), {
    browser: true,
    es2021: true
  });
}
function getExtends(extend) {
  return extend;
}
function getPlugins(plugins) {
  return plugins;
}
function getParserOptions() {
  return {
    ecmaFeatures: {
      jsx: true
    },
    ecmaVersion: 12,
    sourceType: 'module'
  };
}
function getOtherOptions(options) {
  return options;
}
function getRules(rules) {
  return rules;
}